from setuphelpers import *
import json
import re
import requests


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    # Getting latest version from official sources
    re_versions = re.compile(r'puppet-agent-(\d+\.\d+\.\d+)-x86\.msi')
    index = wgets("https://downloads.puppet.com/windows/puppet8", proxies=proxies)

    # Recherche de la dernière version dans le contenu de la page
    versions = re_versions.findall(index)
    if versions:
        latest_version = sorted(versions, key=lambda v: Version(v), reverse=True)[0]
        latest_bin = f"puppet-agent-{latest_version}-x86.msi"
        download_url = f"https://downloads.puppet.com/windows/puppet8/{latest_bin}"

        # Vérification si le fichier existe
        if not requests.head(download_url, proxies=proxies).status_code != 404:
            version = latest_version            

    # remove files
    for f in glob.glob("*.msi"):
        if f != latest_bin:
            remove_file(f)

    # Downloading latest binaries
    wget(download_url, latest_bin, proxies=proxies)

    version =get_version_from_binary(latest_bin)
    control.set_software_version(version)
    control.save_control_to_wapt()